package gregapi.recipes.maps;

import static gregapi.data.CS.F;
import static gregapi.data.CS.T;
import gregapi.GT_API;
import gregapi.data.IL;
import gregapi.random.IHasWorldAndCoords;
import gregapi.recipes.Recipe;
import gregapi.util.UT;

import java.util.Collection;

import net.minecraft.item.ItemStack;
import net.minecraftforge.fluids.FluidStack;

/**
 * @author Gregorius Techneticies
 */
public class RecipeMapRecycler extends RecipeMapNonGTRecipes {
	public RecipeMapRecycler(Collection<Recipe> aRecipeList, String aUnlocalizedName, String aNameLocal, String aNameNEI, long aProgressBarDirection, long aProgressBarAmount, String aNEIGUIPath, long aInputItemsCount, long aOutputItemsCount, long aMinimalInputItems, long aInputFluidCount, long aOutputFluidCount, long aMinimalInputFluids, long aMinimalInputs, long aPower, String aNEISpecialValuePre, long aNEISpecialValueMultiplier, String aNEISpecialValuePost, boolean aShowVoltageAmperageInNEI, boolean aNEIAllowed, boolean aConfigAllowed, boolean aNeedsOutputs) {
		super(aRecipeList, aUnlocalizedName, aNameLocal, aNameNEI, aProgressBarDirection, aProgressBarAmount, aNEIGUIPath, aInputItemsCount, aOutputItemsCount, aMinimalInputItems, aInputFluidCount, aOutputFluidCount, aMinimalInputFluids, aMinimalInputs, aPower, aNEISpecialValuePre, aNEISpecialValueMultiplier, aNEISpecialValuePost, aShowVoltageAmperageInNEI, aNEIAllowed, aConfigAllowed, aNeedsOutputs);
	}
	
	@Override
	public Recipe findRecipe(IHasWorldAndCoords aTileEntity, Recipe aRecipe, boolean aNotUnificated, long aSize, ItemStack aSpecialSlot, FluidStack[] aFluids, ItemStack... aInputs) {
		if (aInputs == null || aInputs.length <= 0 || aInputs[0] == null) return null;
		if (aRecipe != null && aRecipe.isRecipeInputEqual(F, T, aFluids, aInputs)) return aRecipe;
	    return new Recipe(F, F, new ItemStack[] {UT.Stacks.amount(1, aInputs[0])}, GT_API.sCompatIC2 != null && GT_API.sCompatIC2.recycler(UT.Stacks.amount(64, aInputs[0]), 0) == null ? null : new ItemStack[] {IL.IC2_Scrap.get(1)}, null, new long[] {1250}, null, null, 45, 1, 0);
	}
	
	@Override public boolean containsInput(ItemStack aStack, ItemStack aSpecialSlot) {return GT_API.sCompatIC2 == null || GT_API.sCompatIC2.recycler(UT.Stacks.amount(64, aStack), 0) != null;}
}